package oop6_dat6_ss;

import java.io.*;

/**
 * Serialisierung: Objekte schreiben und lesen
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 */
public class DemoSerialization
{

    public static void main(String[] args)
    {
        try {
            // Matrix definieren
            Matrix m1 = new Matrix(3, 4);
            m1.setElt(0, 0, 1); // row, col, value
            m1.setElt(1, 1, 2);
            m1.setElt(2, 2, 3);
            m1.print();

            Matrix m2 = new Matrix(2, 2);
            m2.setElt(0, 1, 5);
            m2.setElt(1, 0, 7);
            m2.print();

            // matrix in file schreiben - serialization
            FileOutputStream aFileOutputStream = new FileOutputStream("matrix.dat");
            ObjectOutputStream aObjectOutputStream = new ObjectOutputStream(aFileOutputStream);
            aObjectOutputStream.writeObject(m1);
            aObjectOutputStream.writeObject(m2);
            aFileOutputStream.close();

            // matrix aus file lesen - (de)serialization
            FileInputStream aFileInputStream = new FileInputStream("matrix.dat");
            ObjectInputStream aObjectInputStream = new ObjectInputStream(aFileInputStream);
            Object o = aObjectInputStream.readObject();
            Object o2 = aObjectInputStream.readObject();
            aFileInputStream.close();
            
            // eingelesens Object ist vom Typ Object -> Cast auf Matrix
            Matrix m3 = (Matrix) o;
            Matrix m4 = (Matrix) o2;
            m3.print();
            m4.print();
        } catch (Exception e) {
            System.out.println("Exception: " + e.getMessage());
        }
    }
}
